;; Prototype file of Scheme parser.
;; Written by yhara (Yutaka HARA)
;; This file is PUBLIC DOMAIN.
;;
;; you need following macros:
;; when let1 inc! dec! while define-constant
;;


;;/* Place package & import here */

;; token values 
;; ex. (define NUMBER 257)
(define-constant YYERRTOK 256)
(define-constant NUMBER 257)

(define yyval #f)
(define yyp #f)

;; TODO: ifndef
(define-constant YYMAXDEPTH 512)

;; Debug mode flag 
;; TODO.
(define yydebug #f)
(define (debug str) (print str))

;;/** lexical element object **/
(define yylval #f)


(define (yyflush) #f) ;;dummy?

(define yytranslate #( 
      0    10    10    10    10    10    10    10    10    10 
      7    10    10    10    10    10    10    10    10    10 
     10    10    10    10    10    10    10    10    10    10 
     10    10    10    10    10    10    10    10    10    10 
      8     9     5     3    10     4    10     6    10    10 
     10    10    10    10    10    10    10    10    10    10 
     10    10    10    10    10    10    10    10    10    10 
     10    10    10    10    10    10    10    10    10    10 
     10    10    10    10    10    10    10    10    10    10 
     10    10    10    10    10    10    10    10    10    10 
     10    10    10    10    10    10    10    10    10    10 
     10    10    10    10    10    10    10    10    10    10 
     10    10    10    10    10    10    10    10    10    10 
     10    10    10    10    10    10    10    10    10    10 
     10    10    10    10    10    10    10    10    10    10 
     10    10    10    10    10    10    10    10    10    10 
     10    10    10    10    10    10    10    10    10    10 
     10    10    10    10    10    10    10    10    10    10 
     10    10    10    10    10    10    10    10    10    10 
     10    10    10    10    10    10    10    10    10    10 
     10    10    10    10    10    10    10    10    10    10 
     10    10    10    10    10    10    10    10    10    10 
     10    10    10    10    10    10    10    10    10    10 
     10    10    10    10    10    10    10    10    10    10 
     10    10    10    10    10    10    10    10    10    10 
     10    10    10    10    10    10     1     2
  ))

(define-constant YYBADCH  10)
(define-constant YYMAXLEX  258)
(define-constant YYTERMS  10)
(define-constant YYNONTERMS  5)

(define yyaction #(
     19    -1    12     7     8     5     6     0    18     5 
      6    24    25    17     0     0     0     0     4
  ))

(define-constant YYLAST 19)

(define yycheck #(
      7     0     1     5     6     3     4     0     7     3 
      4     9     2     7    -1    -1    -1    -1     8
  ))

(define yybase #(
      0     1     6     2    10    10    10    10    10    -2 
     -2     7    -7     0    10    -2    -2
  ))

(define-constant YY2TBLSTATE 4)

(define yydefault #(
      2 32767 32767 32767 32767 32767 32767 32767 32767     7 
      8 32767 32767
  ))

(define yygoto #(
      3     9    10    22    23
  ))

(define-constant YYGLAST 5)

(define yygcheck #(
      1     1     1     1     1
  ))

(define yygbase #(
      0    -4     0     0     0
  ))

(define yygdefault #(
  -32768     2    11     1    16
  ))

(define yylhs #(
      0     2     3     3     4     4     4     1     1     1 
      1     1     1
  ))

(define yylen #(
      1     1     0     2     2     1     2     3     3     3 
      3     3     1
  ))

(define-constant YYSTATES  21)
(define-constant YYNLSTATES  13)
(define-constant YYINTERRTOK  1)
(define-constant YYUNEXPECTED  32767)
(define-constant YYDEFAULT  -32766)

;/*
; * Parser entry point
; */

(define (yyparse)
  (call/cc (lambda (return)

    (define yyastk (make-vector YYMAXDEPTH))
    (define yysstk (make-vector YYMAXDEPTH))

    (define (found-in-action yyn yystate yychar yycheck)
      (or (and (>= yyn 0) 
               (< yyn YYLAST) 
               (= (vector-ref yycheck yyn) yychar))
          (and (< yystate YY2TBLSTATE)
               (or (set! yyn (+ (vector-ref yybase (+ yystate YYNLSTATES)) yychar)) 
            yyn)
               (< yyn YYLAST) 
               (= (vector-ref yycheck yyn) yychar))))

    (let ((yyn #f)
          (yyl #f)
          (yystate 0)
          (yychar -1)
          (yysp 0)
          (yyerrflag 0))
      (vector-set! yysstk yysp 0)

      (let loop ()
        ;; TODO: trace
        
        (if (= 0 (vector-ref yybase yystate))
          (set! yyn #?=(vector-ref yydefault yystate))
          (begin
            (when (< yychar 0)
              (set! yychar (yylex))
              (when (<= yychar 0) (set! yychar 0))
              (set! yychar 
                (if (< yychar YYMAXLEX) 
                  (vector-ref yytranslate yychar)
                  YYBADCH)))

            #?=(list yychar yyn)
            (set! yyn (+ (vector-ref yybase yystate) yychar))
            (if (and (found-in-action yyn yystate yychar yycheck)
                     (or (set! yyn (vector-ref yyaction yyn))
                       (not (= yyn YYDEFAULT))))
              (begin
                 ; >= YYNLSTATE: shift and reduce
                 ; > 0: shift
                 ; = 0: accept
                 ; < 0: reduce
                 ; = -YYUNEXPECTED: error
                (if (<= yyn 0)
                  (set! yyn (- yyn))
                  (begin
                    ;/* shift */
                    (inc! yysp)
                    (vector-set! yysstk yysp yyn)
                    (set! yystate yyn)
                    (vector-set! yyastk yysp yylval)
                    (set! yychar -1)
                    
                    (when (> yyerrflag 0) 
                      (dec! yyerrflag))
                    (when (< yyn YYNLSTATES)
                      (loop))
                      
                    ;/* yyn >= YYNLSTATES means shift-and-reduce */
                    (dec! yyn YYNLSTATES))))
              (set! yyn (vector-ref yydefault yystate)))))
          
        ;/* reduce/error */
        (let inner-loop ()
          #?=yyn
          (cond 
            ;/* accept */
            ((= yyn 0)
              (debug "accept")
              (yyflush)
              (return 0))
              
            ;;/* reduce */
            ((not (= yyn YYUNEXPECTED))
              (debug "reduce")
              (set! yyl (vector-ref yylen yyn))
              (set! yyval (vector-ref yyastk (+ (- yysp yyl) 1)))
              ;/* Following line will be replaced by reduce actions */
              (case yyn
                ((4)  (print (string->number (vector-ref yyastk (- yysp (- 2 1))))) )
                ((5)  (print "(empty line ignored)") )
                ((7)  (set! yyval (+ (string->number (vector-ref yyastk (- yysp (- 3 1)))) (string->number (vector-ref yyastk (- yysp (- 3 3)))))) )
                ((8)  (set! yyval (- (string->number (vector-ref yyastk (- yysp (- 3 1)))) (string->number (vector-ref yyastk (- yysp (- 3 3)))))) )
                ((9)  (set! yyval (* (string->number (vector-ref yyastk (- yysp (- 3 1)))) (string->number (vector-ref yyastk (- yysp (- 3 3)))))) )
                ((10)  (set! yyval (/ (string->number (vector-ref yyastk (- yysp (- 3 1)))) (string->number (vector-ref yyastk (- yysp (- 3 3)))))) )
                ((11)  (set! yyval (string->number (vector-ref yyastk (- yysp (- 3 2))))) )
                ((12)  (set! yyval (string->number (vector-ref yyastk (- yysp (- 1 1))))) )
              )
              ;/* Goto - shift nonterminal */
              (dec! yysp yyl)
              (set! yyn (vector-ref yylhs yyn)) 

              (set! yyp (+ (vector-ref yygbase yyn) (vector-ref yysstk yysp)))
              (if (and (>= yyp 0) 
                       (< yyp YYGLAST)
                       (= (vector-ref yygcheck yyp) yyn))
                (set! yystate (vector-ref yygoto yyp))
                (set! yystate (vector-ref yygdefault yyn)))

              (inc! yysp)
              (vector-set! yysstk yysp yystate)
              (vector-set! yyastk yysp yyval))

            ;;/* error */
            (else
              (debug "error")
              (case #?=yyerrflag
                ((0)
                 (yyerror "syntax error"))
                ((1 2)
                 (set! yyerrflag 3)
                 ;/* Pop until error-expecting state uncovered */
                 (while (not (found_in_action yyn yystate YYINTERRTOK yycheck)) 
                   (when (<= yysp 0)
                     (yyflush)
                     (return 1))
                   (dec! yysp)
                   (set! yystate (vector-ref yysstk yysp)))

                 (set! yyn (vector-ref yyaction yyn))
                 (inc! yysp)
                 (set! yystate yyn)
                 (vector-set! yysstk yysp yyn))
                ((3)
                 (if (= yychar 0)
                   (yyflush)
                   (return 1))
                 (set! yychar -1)))))
            
          ;/* >= YYNLSTATES means shift-and-reduce */
          (when (>= yystate YYNLSTATES)
            (set! yyn (- yystate YYNLSTATES))
            (inner-loop)))
        
        (loop)))
    )))

(define (yylex)
  (let loop ()
    (let1 c (read-char)
      (cond 
        ((eof-object? c) 
         0)
        ((or (char=? #\space c) (char=? #\tab c)) 
         (loop))
        ((char-numeric? c)
         (let1 a (list c)
           (while (char-numeric? (peek-char))
             (push! a (read-char)))
           (set! yylval (string->number (apply string (reverse a)))))
         NUMBER)
        (else
          (char->integer c))))))

(define (yyerror msg)
  (display msg) (newline))

;; main
(define yydebug #t)
(yyparse)
;; vim: set ft=scheme:

/* vim:set ft=scheme:
