#line 1 "kmyacc.c.parser"
/* -*-c-*-  Prototype file of KM-yacc parser for C.
 *
 * Written by MORI Koichiro
 *
 * This file is PUBLIC DOMAIN.
 */


#line 5 "../sample/calc.y"

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#line 14 "kmyacc.c.parser"

#line 20 "kmyacc.c.parser"

#line 22 "kmyacc.c.parser"
#define YYPURE 1
#line 24 "kmyacc.c.parser"

/* declarations */
#line 33 "kmyacc.c.parser"

#ifndef YYSTYPE
#define YYSTYPE int
#endif
#line 38 "kmyacc.c.parser"
extern YYSTYPE yylval;

#define YYERRTOK 256
#define NUMBER 257
#line 44 "kmyacc.c.parser"

/* -p option */
#line 53 "kmyacc.c.parser"


#ifndef YYMAXDEPTH
# define YYMAXDEPTH 512
#endif /* !YYMAXDEPTH */

#ifndef YYASP
# define YYASP(n) yyasp[n]
#endif /* !YYASP */

#define yyclearin (yychar = -1)
#define yyerrok (yyerrflag = 0)
#define YYRECOVERING (yyerrflag != 0)

#define YYACCEPT  return (0)
#define YYABORT  return (1)
#define YYERROR  goto yyerrlab




#if YYDEBUG
int yydebug;
#endif /* YYDEBUG */

#if 0
int yylex();
int yyerror();
#endif

#if !YYPURE
int yychar;
YYSTYPE yylval;
#endif


/* code after %% in *.y */
#line 40 "../sample/calc.y"



#if YYPURE
#define YYLEXARGS YYSTYPE *yylvalp
#define YYLVAL (*yylvalp)
#endif /* YYPURE */

#if !YYPURE
#define YYLEXARGS 
#define YYLVAL yylval
#endif

int yylex(YYLEXARGS)
{
    int c;
    char *p;
    char buf[100];

 again:
    c = getc(stdin);
    if (c == EOF)
        return 0;
    else if (c == ' ' || c == '\t')
        goto again;
    else if (isdigit(c)) {
        for (p = buf; isdigit(c); ) {
            *p++ = c;
            c = getc(stdin);
        }
        *p = '\0';
        ungetc(c, stdin);
        YYLVAL = atoi(buf);
        return NUMBER;
    } else
        return c;
}

int yyerror(s)
char *s;
{
    fprintf(stderr, "%s\n", s);
}

int main()
{
#ifdef YYDEBUG
    yydebug = 1;
#endif

    return yyparse();
}
#line 91 "kmyacc.c.parser"


#if !YYDEBUG

#define YYTRACE_DCL
#define YYTRACE_NEWSTATE(st, tok)
#define YYTRACE_READ(tok)
#define YYTRACE_SHIFT(tok)
#define YYTRACE_ACCEPT()
#define YYTRACE_REDUCE(n)
#define YYTRACE_POP(st)
#define YYTRACE_DISCARD(tok)

#endif /* !YYDEBUG */


#if YYDEBUG

#ifndef EOF
#include <stdio.h>
#endif

#ifndef YYTRACEF
#define YYTRACEF stderr
#endif /* !YYTRACEF */

static char *yyterminals[] = {
  "$EOF",
  "error",
  "NUMBER",
  "'+'",
  "'-'",
  "'*'",
  "'/'",
  "'\\n'",
  "'('",
  "')'"
#line 119 "kmyacc.c.parser"
  , "???"
};

static char *yyproduction[] = {
  "$start : start",
  "start : lines",
  "lines : /* empty */",
  "lines : lines line",
  "line : expr '\\n'",
  "line : '\\n'",
  "line : error '\\n'",
  "expr : expr '+' expr",
  "expr : expr '-' expr",
  "expr : expr '*' expr",
  "expr : expr '/' expr",
  "expr : '(' expr ')'",
  "expr : NUMBER"
#line 124 "kmyacc.c.parser"
};

/* Traditional Debug Mode */

#define YYTRACE_DCL /* empty */

#define YYTRACE_NEWSTATE(st, tok) \
    if (yydebug) \
	fprintf(YYTRACEF, "%%%% State %d, Lookahead %s\n", \
		st, tok < 0 ? "--none--" : yyterminals[tok])

#define YYTRACE_READ(tok) \
    if (yydebug) \
	fprintf(YYTRACEF, "%%%% Reading %s\n", yyterminals[tok])

#define YYTRACE_SHIFT(tok) \
    if (yydebug) \
	fprintf(YYTRACEF, "%%%% Shift %s\n", yyterminals[tok])

#define YYTRACE_ACCEPT() \
    if (yydebug) fprintf(YYTRACEF, "%%%% Accepted.\n")

#define YYTRACE_REDUCE(n) \
    if (yydebug) \
	fprintf(YYTRACEF, "%%%% Reduce by (%d) %s\n", \
		n, yyproduction[n])

#define YYTRACE_POP(st) \
    if (yydebug) \
	fprintf(YYTRACEF, "%%%% Recovering, uncovers state %d\n", \
		st)

#define YYTRACE_DISCARD(tok) \
    if (yydebug) fprintf(YYTRACEF, "%%%% Discard %s\n", yyterminals[tok])

#endif /* YYDEBUG */



static char yytranslate[] = {
    0,   10,   10,   10,   10,   10,   10,   10,   10,   10,
    7,   10,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
    8,    9,    5,    3,   10,    4,   10,    6,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,    1,    2
#line 165 "kmyacc.c.parser"
};

#define YYBADCH 10
#define YYMAXLEX 258
#define YYTERMS 10
#define YYNONTERMS 5

static short yyaction[] = {
   19,   -1,   12,    7,    8,    5,    6,    0,   18,    5,
    6,   24,   25,   17,    0,    0,    0,    0,    4
#line 174 "kmyacc.c.parser"
};
#define YYLAST 19

static char yycheck[] = {
    7,    0,    1,    5,    6,    3,    4,    0,    7,    3,
    4,    9,    2,    7,   -1,   -1,   -1,   -1,    8
#line 179 "kmyacc.c.parser"
};

static short yybase[] = {
    0,    1,    6,    2,   10,   10,   10,   10,   10,   -2,
   -2,    7,   -7,    0,   10,   -2,   -2
#line 183 "kmyacc.c.parser"
};
#define YY2TBLSTATE 4

static short yydefault[] = {
    2,32767,32767,32767,32767,32767,32767,32767,32767,    7,
    8,32767,32767
#line 188 "kmyacc.c.parser"
};

static short yygoto[] = {
    3,    9,   10,   22,   23
#line 192 "kmyacc.c.parser"
};
#define YYGLAST 5

static char yygcheck[] = {
    4,    4,    4,    4,    4
#line 197 "kmyacc.c.parser"
};

static short yygbase[] = {
    0,    0,    0,    0,   -4
#line 201 "kmyacc.c.parser"
};

static short yygdefault[] = {
-32768,   11,    1,   16,    2
#line 205 "kmyacc.c.parser"
};

static char yylhs[] = {
    0,    1,    2,    2,    3,    3,    3,    4,    4,    4,
    4,    4,    4
#line 209 "kmyacc.c.parser"
};

static char yylen[] = {
    1,    1,    0,    2,    2,    1,    2,    3,    3,    3,
    3,    3,    1
#line 213 "kmyacc.c.parser"
};

#line 235 "kmyacc.c.parser"

#define YYSTATES 21
#define YYNLSTATES 13
#define YYINTERRTOK 1
#define YYUNEXPECTED 32767
#define YYDEFAULT -32766


/*
 * Seek (st,ch) in action table, return true if found.
 * param n position in yyaction
 * param st current state
 * param ch input token
 */
#if YYPROBEONCE
#define found_in_action(n, st, ch) \
  ((unsigned)(n = yybase[st] + (ch)) < YYLAST && yycheck[n] == (ch))
#endif /* YYPROBEONCE */

#if !YYPROBEONCE
#define found_in_action(n, st, ch) \
  (((unsigned)(n = yybase[st] + (ch)) < YYLAST && yycheck[n] == (ch)) \
   || ((st) < YY2TBLSTATE \
       && (unsigned)(n = yybase[(st) + YYNLSTATES] + (ch)) < YYLAST \
       && yycheck[n] == (ch)))
#endif /* !YYPROBEONCE */

#define found_in_goto(n, st, ch) \
  ((unsigned)(n = yygbase[ch] + (st)) < YYGLAST && yygcheck[n] == (ch))


/*
 * Lexical analyzer interface
 */
#if YYPURE
#  ifdef YYLEX_PARAM
#    define YYLEX() yylex(&yylval, YYLEX_PARAM)
#  else
#    define YYLEX() yylex(&yylval)
#  endif /* YYLEX_PARAM */
#else
#  define YYLEX() yylex()
#endif /* YYPURE */


/*
 * Parser entry point
 */
#ifdef YYPARSE_PARAM
#  if __STDC__
#    define YYPARSE_ARG void *YYPARSE_PARAM
#    define YYPARSE_DECL
#  else
#    define YYPARSE_ARG YYPARSE_PARAM
#    define YYPARSE_DECL void *YYPARSE_PARAM;
#  endif /* __STDC__ */
#else
# define YYPARSE_ARG
# define YYPARSE_DECL
#endif /* YYPARSE_PARAM */

int yyparse(YYPARSE_ARG)
  YYPARSE_DECL
{
  YYSTYPE yyastk[YYMAXDEPTH];
  short yysstk[YYMAXDEPTH];
  short *yyssp;
  int yystate;
  int yyn;
  int yyp;
  int yyl;
  int yychar1;
#if YYPURE
  int yychar;
  YYSTYPE yylval;
#endif /* YYPURE */
  int yyerrflag;
  YYSTYPE *yyasp;
#ifndef YYACTFUN
  YYSTYPE yyval;
#endif /* !YYACTFUN */
  YYTRACE_DCL

  yyssp = yysstk;
  yyasp = yyastk - 1;
  *yyssp = yystate = 0;
  yychar1 = yychar = -1;
  yyerrflag = 0;
  for (;;) {
    YYTRACE_NEWSTATE(yystate, yychar1);

    if (yybase[yystate] == 0)
      yyn = yydefault[yystate];
    else {
      if (yychar < 0) {
        if ((yychar = YYLEX()) <= 0) yychar = 0;
        yychar1 = yychar < YYMAXLEX ? yytranslate[yychar] : YYBADCH;
        YYTRACE_READ(yychar1);
      }
      
      if (found_in_action(yyn, yystate, yychar1)
          && (yyn = yyaction[yyn]) != YYDEFAULT) {
        /*
         * >= YYNLSTATE: shift and reduce
         * > 0: shift
         * = 0: accept
         * < 0: reduce
         * = -YYUNEXPECTED: error
         */
        if (yyn > 0) {
          /* shift */
          YYTRACE_SHIFT(yychar1);
          if (yyssp >= yysstk + YYMAXDEPTH) {
            yyerror("parser stack overflow");
            YYABORT;
          }
          *++yyssp = yystate = yyn;
          *++yyasp = yylval;
          yychar1 = yychar = -1;

          if (yyerrflag > 0)
            yyerrflag--;
          if (yyn < YYNLSTATES)
            continue;

          /* yyn >= YYNLSTATES means shift-and-reduce */
          yyn -= YYNLSTATES;
        } else
          yyn = -yyn;
      } else
        yyn = yydefault[yystate];
    }

    for (;;) {
      /* reduce/error */
      if (yyn == 0) {
        /* accept */
        YYTRACE_ACCEPT();
        YYACCEPT;
      }
      else if (yyn != YYUNEXPECTED) {
        /* reduce */
        yyl = yylen[yyn];
        yyval = yyasp[1-yyl];
        YYTRACE_REDUCE(yyn);
#line 384 "kmyacc.c.parser"
        switch(yyn) {
        case 4:
#line 26 "../sample/calc.y"
{ printf("%d\n", YYASP(1-2)); } break;
        case 5:
#line 27 "../sample/calc.y"
{ printf("(empty line ignored)\n"); } break;
        case 7:
#line 31 "../sample/calc.y"
{ yyval = YYASP(1-3) + YYASP(3-3); } break;
        case 8:
#line 32 "../sample/calc.y"
{ yyval = YYASP(1-3) - YYASP(3-3); } break;
        case 9:
#line 33 "../sample/calc.y"
{ yyval = YYASP(1-3) * YYASP(3-3); } break;
        case 10:
#line 34 "../sample/calc.y"
{ yyval = YYASP(1-3) / YYASP(3-3); } break;
        case 11:
#line 35 "../sample/calc.y"
{ yyval = YYASP(2-3); } break;
        case 12:
#line 36 "../sample/calc.y"
{ yyval = YYASP(1-1); } break;
#line 389 "kmyacc.c.parser"
        }
#line 391 "kmyacc.c.parser"

        /* Goto - shift nonterminal */
        yyasp -= yyl;
        yyssp -= yyl;
        yyn = yylhs[yyn];
        if (found_in_goto(yyp, *yyssp, yyn))
          yystate = yygoto[yyp];
        else
          yystate = yygdefault[yyn];

        if (yyssp >= yysstk + YYMAXDEPTH) {
          yyerror("parser stack overflow");
          YYABORT;
        }
        *++yyssp = yystate;
        *++yyasp = yyval;

      }
      else {
        /* error */
        switch (yyerrflag) {
        case 0:
        yyerrlab:
          yyerror("syntax error");
        case 1:
        case 2:
          yyerrflag = 3;
          /* Pop until error-expecting state uncovered */
          while (!found_in_action(yyn, yystate, YYINTERRTOK)) {
            if (yyssp <= yysstk)
              YYABORT;
            yystate = *--yyssp;
            yyasp--;
            YYTRACE_POP(yystate);
          }
          yyn = yyaction[yyn];
          YYTRACE_SHIFT(YYINTERRTOK);
          *++yyssp = yystate = yyn;
          ++yyasp;
          break;

        case 3:
          YYTRACE_DISCARD(yychar1);
          if (yychar == 0)
            YYABORT;
          yychar1 = yychar = -1;
          break;
        }
      }

      if (yystate < YYNLSTATES)
        break;
      /* >= YYNLSTATES means shift-and-reduce */
      yyn = yystate - YYNLSTATES;
    }
  }
}
/* vim:set ft=c: */
